#ifndef CUSTOMWIDGETS_H_
#define CUSTOMWIDGETS_H_

#include <QtCore/QList>
#include <QtCore/QtPlugin>
#include <QtDesigner/QDesignerCustomWidgetCollectionInterface>
#include "customwidget.h"

#include "../embedded-widgets-1.1.0/src/5waybutton/qt5waybutton.h"
#include "../embedded-widgets-1.1.0/src/basicdialgauge/qtbasicdialgauge.h"
#include "../embedded-widgets-1.1.0/src/basicgraph/qtbasicgraph.h"
#include "../embedded-widgets-1.1.0/src/common/qtsvgpixmapcache.h"
#include "../embedded-widgets-1.1.0/src/multislider/qtmultislider.h"
#include "../embedded-widgets-1.1.0/src/scrolldial/qtscrolldial.h"
#include "../embedded-widgets-1.1.0/src/scrolldial/scrolldialpopup.h"
#include "../embedded-widgets-1.1.0/src/scrollwheel/qtscrollwheel.h"
#include "../embedded-widgets-1.1.0/src/svgbutton/qtsvgbutton.h"
#include "../embedded-widgets-1.1.0/src/svgdialgauge/qtsvgdialgauge.h"
#include "../embedded-widgets-1.1.0/src/svgslideswitch/qtsvgslideswitch.h"
#include "../embedded-widgets-1.1.0/src/svgtoggleswitch/qtsvgtoggleswitch.h"

// Qt5WayButton
class Qt5WayButton_CW : public QObject, public CustomWidget<Qt5WayButton>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit Qt5WayButton_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtBasicGraph
class QtBasicGraph_CW : public QObject, public CustomWidget<QtBasicGraph>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtBasicGraph_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtMultiSlider
class QtMultiSlider_CW : public QObject, public CustomWidget<QtMultiSlider>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtMultiSlider_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtScrollDial
class QtScrollDial_CW : public QObject, public CustomWidget<QtScrollDial>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtScrollDial_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtScrollWheel
class QtScrollWheel_CW : public QObject, public CustomWidget<QtScrollWheel>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtScrollWheel_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtSvgButton
class QtSvgButton_CW : public QObject, public CustomWidget<QtSvgButton>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtSvgButton_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtSvgDialGauge
class QtSvgDialGauge_CW : public QObject, public CustomWidget<QtSvgDialGauge>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtSvgDialGauge_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtSvgSlideSwitch
class QtSvgSlideSwitch_CW : public QObject, public CustomWidget<QtSvgSlideSwitch>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtSvgSlideSwitch_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

// QtSvgToggleSwitch
class QtSvgToggleSwitch_CW : public QObject, public CustomWidget<QtSvgToggleSwitch>
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetInterface)
public:
	explicit QtSvgToggleSwitch_CW(QObject* parent = 0);
	QWidget* createWidget(QWidget* parent);
};

//--------------------------------------------------------------------------------------

// Collection
class WidgetCollection : public QObject, public QDesignerCustomWidgetCollectionInterface
{
	Q_OBJECT
	Q_INTERFACES(QDesignerCustomWidgetCollectionInterface)

public:
	explicit WidgetCollection(QObject* parent = 0);

	QList<QDesignerCustomWidgetInterface*> customWidgets() const;

private:
	QList<QDesignerCustomWidgetInterface*> m_plugins;
};

#endif /* CUSTOMWIDGETS_H_ */
